diff --git a/game/client/src/main/java/net/minecraft/client/input/sdl/SDLGamepad.java b/game/client/src/main/java/net/minecraft/client/input/sdl/SDLGamepad.java
new file mode 100644
index 000000000..05a68b310
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/input/sdl/SDLGamepad.java
@@ -0,0 +1,129 @@
+package net.minecraft.client.input.sdl;
+
+import net.minecraft.client.input.controller.Button;
+import net.minecraft.client.input.controller.Joystick;
+import org.jetbrains.annotations.NotNull;
+import org.libsdl.*;
+
+import java.io.IOException;
+
+public class SDLGamepad {
+    private static final float AXIS_MIN = SDL.SDL_JOYSTICK_AXIS_MIN();
+    private static final float AXIS_MAX = SDL.SDL_JOYSTICK_AXIS_MAX();
+
+    private final int instanceId;
+    private final long joystickPtr;
+    private final long gameControllerPtr;
+    private final int vid;
+    private final int did;
+
+    public SDLGamepad(final int index) throws Exception {
+        this.joystickPtr = SDL.SDL_JoystickOpen(index);
+        if (this.joystickPtr == 0) {
+            throw new IOException(SDL.SDL_GetError());
+        }
+        this.gameControllerPtr = SDL.SDL_GameControllerOpen(index);
+        if (this.gameControllerPtr == 0) {
+            throw new IOException(SDL.SDL_GetError());
+        }
+
+        this.instanceId = SDL.SDL_JoystickInstanceID(this.joystickPtr);
+
+        // Determine VID and DID
+        String guid = this.getGuid();
+
+        int vid;
+        try {
+            String lower = guid.substring(8, 10);
+            String upper = guid.substring(10, 12);
+            vid = Integer.parseInt(upper + lower, 16);
+        } catch (Exception e) {
+            System.out.println("Controller " + index + " has weird GUID!");
+            this.vid = 0;
+            this.did = 0;
+            return;
+        }
+
+        int did;
+        try {
+            String lower = guid.substring(16, 18);
+            String upper = guid.substring(18, 20);
+            did = Integer.parseInt(upper + lower, 16);
+        } catch (Exception e) {
+            System.out.println("Controller " + index + " has weird GUID!");
+            this.vid = 0;
+            this.did = 0;
+            return;
+        }
+
+        this.vid = vid;
+        this.did = did;
+    }
+
+    @Override
+    protected void finalize() throws Throwable {
+        super.finalize();
+        SDL.SDL_GameControllerClose(this.gameControllerPtr);
+        SDL.SDL_JoystickClose(this.joystickPtr);
+    }
+
+    public int getInstanceId() {
+        return this.instanceId;
+    }
+
+    public @NotNull String getGuid() {
+        return SDL.SDL_JoystickGUIDString(this.joystickPtr);
+    }
+
+    public int getVendorId() {
+        return this.vid;
+    }
+
+    public int getDeviceId() {
+        return this.did;
+    }
+
+    public boolean isPresent() {
+        return SDL.SDL_GameControllerGetAttached(this.gameControllerPtr);
+    }
+
+    public @NotNull String getName() {
+        return SDL.SDL_GameControllerName(gameControllerPtr);
+    }
+
+    public boolean hasAnyInput() {
+        for (int i = 0; i < SDL.SDL_CONTROLLER_BUTTON_MAX; i++) {
+            if (isButtonPressed(i)) {
+                return true;
+            }
+        }
+        for (int i = 0; i < SDL.SDL_CONTROLLER_AXIS_MAX; i++) {
+            if (Math.abs(getAxisValue(i)) > 0.5f) {
+                return true;
+            }
+        }
+
+        return false;
+    }
+
+    public float getAxisValue(final int axis) {
+        if (isPresent()) {
+            final int result = SDL.SDL_GameControllerGetAxis(this.gameControllerPtr, axis);
+            if (result < 0) {
+                return (float) result / -AXIS_MIN;
+            } else {
+                return (float) result / AXIS_MAX;
+            }
+        }
+
+        return 0.0f;
+    }
+
+    public boolean isButtonPressed(final int button) {
+        if (isPresent()) {
+            return SDL.SDL_GameControllerGetButton(this.gameControllerPtr, button) == 1;
+        }
+
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index bd6fe3f60..d964c6903 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -107,7 +107,7 @@ public class GameSettings {
 	public OptionColor guiBackgroundColor = new OptionColor(this, "guiBackgroundColor", new Color().setARGB(0xc0101010));
 	public OptionEnum<Difficulty> difficulty = new OptionEnum<>(this, "difficulty", Difficulty.class, Difficulty.NORMAL); // Stub for local difficulty setting
 	public OptionInteger thirdPersonView = new OptionInteger(this, "thirdPersonView", 0);
-	public OptionRange renderDistance = new OptionRange(this, "renderDistance", 8, 2, 64);
+	public OptionRange renderDistance = new OptionRange(this, "renderDistance", 12, 2, 32);
 	public OptionBoolean enableVsync = new OptionBoolean(this, "enableVsync", false);
 	public OptionEnum<ChatVisibility> chatVisibility = new OptionEnum<>(this, "chatVisibility", ChatVisibility.class, ChatVisibility.SHOW_ALL);
 	public OptionRange customFpsLimit = new OptionRange(this,"customFpsLimit",0,241);
@@ -155,7 +155,7 @@ public class GameSettings {
 	public OptionRange mipmapLevels = new OptionRange(this, "mipmapLevels", 0, 5);
 	public OptionEnum<MipmapType> mipmapType = new OptionEnum<>(this, "mipmapType", MipmapType.class, MipmapType.SMOOTH);
 
-	public OptionBoolean fullscreen = new OptionBoolean(this, "fullscreen", false);
+	public OptionBoolean fullscreen = new OptionBoolean(this, "fullscreen", Minecraft.isClientASteamDeck());
 	public OptionBoolean borderlessFullscreen = new OptionBoolean(this, "borderlessFullscreen", true);
 	public OptionBoolean startInFullscreen = new OptionBoolean(this, "startInFullscreen", true);
 	public OptionEnum<TooltipStyle> tooltipStyle = new OptionEnum<>(this, "tooltipStyle", TooltipStyle.class);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 693dacd99..661b1477e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -726,6 +726,8 @@ public class BlockModelDispatcher
 
         addDispatch(new BlockModelLamp<>(Blocks.LAMP_IDLE));
         addDispatch(new BlockModelLamp<>(Blocks.LAMP_ACTIVE));
+        addDispatch(new BlockModelLamp<>(Blocks.LAMP_INVERTED_IDLE));
+        addDispatch(new BlockModelLamp<>(Blocks.LAMP_INVERTED_ACTIVE));
 
         addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_GREEN).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lantern_firefly/green"));
         addDispatch(new BlockModelLantern<>(Blocks.LANTERN_FIREFLY_BLUE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/lantern_firefly/blue"));
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index fe01435f7..badffbf21 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -137,14 +137,10 @@ public abstract class Achievements
         new Achievement(new NamespaceID("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
-    public static Achievement ENTER_OLDWORLD =
-        new Achievement(new NamespaceID("minecraft", "enter_oldworld"), "enterOldworld", Blocks.BEDROCK, ENTER_NETHER)
-            .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement();
-    public static Achievement ENTER_WARRENS =
-        new Achievement(new NamespaceID("minecraft", "enter_warrens"), "enterWarrens", Blocks.BEDROCK, ENTER_NETHER)
-            .setType(Achievement.TYPE_NORMAL)
-            .registerAchievement();
+//    public static Achievement ENTER_WARRENS =
+//        new Achievement(new NamespaceID("minecraft", "enter_warrens"), "enterWarrens", Blocks.BEDROCK, ENTER_NETHER)
+//            .setType(Achievement.TYPE_NORMAL)
+//            .registerAchievement();
     public static Achievement MOST_WANTED =
         new Achievement(new NamespaceID("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index 2c79ee608..a916e98f7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -11,16 +11,24 @@ import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicLamp extends BlockLogic implements IPainted {
     public boolean isActive;
+    public boolean isInverted;
 
-    public BlockLogicLamp(Block<?> block, boolean isActivated) {
+    public BlockLogicLamp(Block<?> block, boolean isActive, boolean isInverted) {
         super(block, Material.stone);
-        isActive = isActivated;
+        this.isActive = isActive;
+        this.isInverted = isInverted;
     }
 
     @Override
     public void onBlockPlacedByWorld(World world, int x, int y, int z) {
-        if (isActive && !(world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+        if (isInverted) {
+            if (isActive && (world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
+            }
+        } else {
+            if (isActive && !(world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z))) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+            }
         }
     }
 
@@ -32,10 +40,18 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
 
         final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
 
-        if (hasSignal && !isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
-        } else if (!hasSignal && isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+        if (isInverted) {
+            if (hasSignal && isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
+            } else if (!hasSignal && !isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            }
+        } else {
+            if (hasSignal && !isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            } else if (!hasSignal && isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+            }
         }
     }
 
@@ -43,16 +59,28 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         final boolean hasSignal = world.hasDirectSignal(x, y, z) || world.hasNeighborSignal(x, y, z);
 
-        if (hasSignal && !isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
-        } else if (!hasSignal && isActive) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+        if (isInverted) {
+            if (hasSignal && isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockMetadata(x, y, z));
+            } else if (!hasSignal && !isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            }
+        } else {
+            if (hasSignal && !isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_ACTIVE.id(), world.getBlockMetadata(x, y, z));
+            } else if (!hasSignal && isActive) {
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.LAMP_IDLE.id(), world.getBlockMetadata(x, y, z));
+            }
         }
     }
 
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
-        return new ItemStack[]{new ItemStack(Blocks.LAMP_IDLE, 1, meta)};
+        if (isInverted) {
+            return new ItemStack[] { new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, meta) };
+        } else {
+            return new ItemStack[] { new ItemStack(Blocks.LAMP_IDLE, 1, meta) };
+        }
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 7e6fce258..836c549aa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1098,13 +1098,20 @@ public final class Blocks {
         .withSound(BlockSounds.CLOTH).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange().withOverrideColor(MaterialColor.paintedOrange).setStatParent(() -> Items.FOOD_PUMPKIN_PIE)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.NOT_IN_CREATIVE_MENU);
 
-    public static final Block<BlockLogicLamp> LAMP_IDLE = register("lamp.idle", "minecraft:block/lamp_idle", 850, (BlockLogicSupplier<BlockLogicLamp>)b -> new BlockLogicLamp(b, false))
+    public static final Block<BlockLogicLamp> LAMP_IDLE = register("lamp.idle", "minecraft:block/lamp_idle", 850, (BlockLogicSupplier<BlockLogicLamp>)b -> new BlockLogicLamp(b, false, false))
         .withSound(BlockSounds.GLASS).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
         .setBlockItem(ItemBlockLamp::new)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<BlockLogicLamp> LAMP_ACTIVE = register("lamp.active", "minecraft:block/lamp_active", 851, (BlockLogicSupplier<BlockLogicLamp>)b -> new BlockLogicLamp(b, true))
+    public static final Block<BlockLogicLamp> LAMP_ACTIVE = register("lamp.active", "minecraft:block/lamp_active", 851, (BlockLogicSupplier<BlockLogicLamp>)b -> new BlockLogicLamp(b, true, false))
         .withSound(BlockSounds.GLASS).withLightEmission(0.9375F).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> LAMP_IDLE)
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<BlockLogicLamp> LAMP_INVERTED_IDLE = register("lamp.inverted.idle", "minecraft:block/lamp_inverted_idle", 852, (BlockLogicSupplier<BlockLogicLamp>)b -> new BlockLogicLamp(b, false, true))
+        .withSound(BlockSounds.GLASS).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Blocks.LAMP_INVERTED_ACTIVE)
+        .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final Block<BlockLogicLamp> LAMP_INVERTED_ACTIVE = register("lamp.inverted.active", "minecraft:block/lamp_inverted_active", 853, (BlockLogicSupplier<BlockLogicLamp>)b -> new BlockLogicLamp(b, true, true))
+        .withSound(BlockSounds.GLASS).withLightEmission(0.9375F).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
+        .setBlockItem(ItemBlockLamp::new)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block<?> LANTERN_FIREFLY_GREEN = register("lantern.firefly.green", "minecraft:block/lantern_firefly_green", 870,
         (b) -> new BlockLogicLanternFirefly(b, MobFireflyCluster.FireflyColor.GREEN, () -> Items.LANTERN_FIREFLY_GREEN))
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index 38bd36bb4..f678818a5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -129,9 +129,9 @@ public class TileEntityActivator extends TileEntity implements Container {
     }
 
     @Override
-    public String getName()
+    public String getNameTranslationKey()
     {
-        return "Activator";
+        return "container.activator.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
index 8c8ab54a9..43b4edcb5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityChest.java
@@ -75,9 +75,9 @@ public class TileEntityChest extends TileEntity
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "Chest";
+        return "container.chest.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
index 1be08e68e..cc9692308 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityDispenser.java
@@ -106,9 +106,9 @@ public class TileEntityDispenser extends TileEntity
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "Trap";
+        return "container.dispenser.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
index 62f1c4983..dc88c5ca3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
@@ -261,9 +261,9 @@ public class TileEntityFlag extends TileEntity
     }
 
     @Override
-    public String getName()
+    public String getNameTranslationKey()
     {
-        return "Flag";
+        return "container.flag.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
index 5bae21bdc..4197fd6c3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
@@ -93,9 +93,9 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "Furnace";
+        return "container.furnace.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
index 7fec79f08..44f078335 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityFurnaceBlast.java
@@ -24,9 +24,9 @@ public class TileEntityFurnaceBlast extends TileEntityFurnace
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "BlastFurnace";
+        return "container.furnace_blast.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
index e0d3ef1e1..0c87fde72 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
@@ -95,9 +95,9 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "Trommel";
+        return "container.trommel.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index 889b19ca9..940c12e82 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -91,6 +91,7 @@ public class Registries extends Registry<Registry<?>>
             List<ItemStack> trapdoorStackList = new ArrayList<>();
             List<ItemStack> woolStackList = new ArrayList<>();
             List<ItemStack> lampStackList = new ArrayList<>();
+            List<ItemStack> invertedLampStackList = new ArrayList<>();
 
             plankStackList.add(Blocks.PLANKS_OAK.getDefaultStack());
             chestStackList.add(Blocks.CHEST_PLANKS_OAK.getDefaultStack());
@@ -110,11 +111,13 @@ public class Registries extends Registry<Registry<?>>
                 trapdoorStackList.add(new ItemStack(Blocks.TRAPDOOR_PLANKS_PAINTED, 1, color.blockMeta << 4));
                 woolStackList.add(new ItemStack(Blocks.WOOL, 1, color.blockMeta));
                 lampStackList.add(new ItemStack(Blocks.LAMP_IDLE, 1, color.blockMeta));
+                invertedLampStackList.add(new ItemStack(Blocks.LAMP_INVERTED_ACTIVE, 1, color.blockMeta));
             }
             ITEM_GROUPS.register("minecraft:planks",plankStackList);
             ITEM_GROUPS.register("minecraft:chests", chestStackList);
             ITEM_GROUPS.register("minecraft:wools", woolStackList);
             ITEM_GROUPS.register("minecraft:lamps", lampStackList);
+            ITEM_GROUPS.register("minecraft:lamps_inverted", invertedLampStackList);
             ITEM_GROUPS.register("minecraft:stairs_planks", stairsStackList);
             ITEM_GROUPS.register("minecraft:slabs_planks", slabsStackList);
             ITEM_GROUPS.register("minecraft:fences_planks", fencesStackList);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 9dd3683b9..a25b57200 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -203,13 +203,11 @@ public abstract class Player extends Mob
 	public void tick()
     {
         if (world.dimension == Dimension.NETHER) {
-            if (y >= 260) {
-                addStat(Achievements.ENTER_OLDWORLD, 1);
-            } else if (y >=128) {
+            if (y >=128) {
                 addStat(Achievements.ENTER_NETHER, 1);
-            } else {
+            } /* else {
                 addStat(Achievements.ENTER_WARRENS, 1);
-            }
+            }*/
         }
 
         xdO = xd;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
index 50c90b2b7..1af5579d3 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -819,8 +819,8 @@ public class MinecartEntity extends Entity implements Container {
 
 
     @Override
-    public String getName() {
-        return "Minecart";
+    public String getNameTranslationKey() {
+        return "container.minecart.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
index 518c295f1..7e248a3c4 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSeed.java
@@ -6,6 +6,10 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 
+import java.awt.*;
+import java.awt.datatransfer.Clipboard;
+import java.awt.datatransfer.StringSelection;
+
 public class CommandSeed implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("seed")
@@ -13,6 +17,17 @@ public class CommandSeed implements CommandManager.CommandRegistry {
                 .executes(c -> {
                     CommandSource source = c.getSource();
                     source.sendTranslatableMessage("command.commands.seed.success", source.getWorld().getRandomSeed());
+                    if (source.getSender() != null) {
+                        Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
+                        if (clipboard != null) {
+                            try {
+                                clipboard.setContents(new StringSelection(String.valueOf(source.getWorld().getRandomSeed())), null);
+                                source.sendTranslatableMessage("command.commands.seed.copied_to_clipboard");
+                            } catch (Exception ignored) {
+
+                            }
+                        }
+                    }
                     return Command.SINGLE_SUCCESS;
                 })
         );
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java
index 76b0d2754..121c98a65 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSpawn.java
@@ -31,7 +31,7 @@ public class CommandSpawn implements CommandManager.CommandRegistry {
                     if (sender == null) throw CommandExceptions.notInWorld().create();
 
                     if (sender.dimension != 0) source.movePlayerToDimension(sender, 0);
-                    sender.absMoveTo(spawnCoordinates.x + 0.5, spawnCoordinates.y + 1.1 + sender.heightOffset, spawnCoordinates.z + 0.5, sender.yRot, sender.xRot);
+                    sender.absMoveTo(spawnCoordinates.x + 0.5, world.findTopSolidBlock(spawnCoordinates.x, spawnCoordinates.z) + 1.1 + sender.heightOffset, spawnCoordinates.z + 0.5, sender.yRot, sender.xRot);
                     source.sendTranslatableMessage("command.commands.spawn.success");
                     return Command.SINGLE_SUCCESS;
                 })
@@ -46,7 +46,7 @@ public class CommandSpawn implements CommandManager.CommandRegistry {
 
                             for (Entity entity : players) {
                                 if (((Player)entity).dimension != 0) source.movePlayerToDimension((Player) entity, 0);
-                                entity.absMoveTo(spawnCoordinates.x + 0.5, spawnCoordinates.y + 1.1 + entity.heightOffset, spawnCoordinates.z + 0.5, entity.yRot, entity.xRot);
+                                entity.absMoveTo(spawnCoordinates.x + 0.5, world.findTopSolidBlock(spawnCoordinates.x, spawnCoordinates.z) + 1.1 + entity.heightOffset, spawnCoordinates.z + 0.5, entity.yRot, entity.xRot);
                                 if (entity == sender) {
                                     source.sendTranslatableMessage("command.commands.spawn.success");
                                 } else {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
index f3973be22..e96edefe4 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/Container.java
@@ -14,7 +14,7 @@ public interface Container
 
     void setItem(int index, ItemStack itemstack);
 
-    String getName();
+    String getNameTranslationKey();
 
     int getMaxStackSize();
 
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
index f6edc4057..401af74ea 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCompound.java
@@ -25,7 +25,7 @@ public class ContainerCompound
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
         return name;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
index f02b082a2..25748cb99 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerCrafting.java
@@ -62,9 +62,9 @@ public class ContainerCrafting
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "Crafting";
+        return "container.crafting.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
index c843954af..34710a3f3 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerInventory.java
@@ -357,9 +357,9 @@ public class ContainerInventory
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "Inventory";
+        return "container.inventory.name";
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
index c23dc2274..d8fefbe4f 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/container/ContainerResult.java
@@ -26,9 +26,9 @@ public class ContainerResult
     }
 
     @Override
-	public String getName()
+	public String getNameTranslationKey()
     {
-        return "Result";
+        return "container.result.name";
     }
 
     @Override
